package mjc.lib;

import java.util.HashMap;
import java.util.Set;
import java.util.Map;

import mjc.lib.classe.LPARAMS;
import mjc.lib.classe.PARAM;
import mjc.lib.type.DTYPE;

public class TDS extends HashMap<String, VARIABLE> {

	private static final long serialVersionUID = 1L;

	private TDS parente;

	public TDS() {
		this(null);
	}

	public TDS(TDS p) {
		super();
		parente = p;
	}

	public VARIABLE chercherLocalement(String n) {
		return get(n);
	}

	public VARIABLE chercherGlobalement(String n) {
		VARIABLE i = chercherLocalement(n);
		if (i == null)
			if (parente != null)
				return parente.chercherGlobalement(n);
		return i;
	}

	public void inserer(String n, VARIABLE i) {
		put(n, i);
	}
	
	public void ajouter(LPARAMS lp) {
		for(PARAM p : lp) {
			System.out.println("Ajout de " + p);
			DTYPE t = p.getType();
//			int dep = t.getTaille();
			//FIXME
			int dep = 0;
			put(p.getNom(), new VARIABLE(t, dep));
		}
	}
	
	public String toString() {
		StringBuffer sb = new StringBuffer();
		Set<Map.Entry<String, VARIABLE>> s = entrySet();
		for (Map.Entry<String, VARIABLE> e : s){
			sb.append("; " + e.getKey() + " : " + e.getValue() + '\n');
		
		}
		return sb.toString();
	}

	public int getTaille() {
		int retour = 0;
		for(VARIABLE v : this.values()) {
			retour += v.getType().getTaille();
		}
		
		return retour;
	}
}