package mjc.lib.classe;

public class CLASSE {
	
	protected CLASSE parente;
	protected String nom;
	protected LPARAMS attributs;
	protected LMETHODES methodes;
	
	protected int deplacement;

	
//	public CLASSE(String n, LPARAMS p, LMETHODES m){
//		this.nom = n;
//		this.attributs = p;
//		this.methodes = m;
//	}
	
	public CLASSE(String n, int dep) {
		this.nom = n;
		this.deplacement = dep;
		this.attributs = new LPARAMS();
		this.methodes = new LMETHODES();
	}
	
	public String getNom(){
		return this.nom;
	}
	
	public int getDeplacement() {
		return deplacement;
	}
	
	public CLASSE getParente(){
		return parente;
	}
	public void setParente(CLASSE p) {
		this.parente = p;
		this.attributs.addAll(p.getAttributs());
		heriterMethodes(parente.getMethodes());
	}
	
	public LPARAMS getAttributs(){
		return this.attributs;
	}
	
	public LMETHODES getMethodes(){
		return this.methodes;
	}
	
	/** Compte le nombre de méthode (pas de constructeur !) de la classe. */
	public int getNbMethodes() {
		int retour = 0;
		for(METHODE m : methodes) {
			if (!m.getNom().equals(this.nom)) {
				retour++;
			}
		}
		return retour;
	}
	
	private void heriterMethodes(LMETHODES methodes) {
		for(METHODE m : methodes) {
			// On hérite pas des constructeurs ni de main
			String nom = m.getNom();
			if(nom.equals(parente.getNom()) ||nom.equals("main")) {
//				METHODE c = new METHODE(this.nom, m.getType(), m.getParams());
//				this.methodes.add(c);
			} else {
//				m.setRedefinie(false);
				this.methodes.add(m);
			}
		}
	}
	
	// A extends B
	// A.compareTo(B) -> TRUE
	// B.compareTo(A) -> FALSE
	public boolean compareTo(CLASSE c){
		return (nom.equals(c.getNom())||(((parente!=null)&&parente.compareTo(c))));
	}
	
	public String toString(){
		StringBuffer sb = new StringBuffer();
		sb.append("Classe : " + nom + "\n");
		sb.append("Liste des attributs : \n");
		for(PARAM p : attributs) {
			sb.append(p.toString() + "\n");
		}
		sb.append("Liste des méthodes : \n");
		for(METHODE m : methodes) {
			sb.append(m.toString() + "\n");
		}
		return sb.toString();
	}
}
