package mjc.lib.classe;
import java.util.ArrayList;
import mjc.lib.type.DTYPE;

public class LPARAMS extends ArrayList<PARAM>{
	
	private static final long serialVersionUID = 1L;

	public void inserer(PARAM p){
		add(p);
	}
	
	public void inserer(String nom, DTYPE type, int dep){
		add(new PARAM(nom,type,dep));
	}

	public PARAM chercher(String nom){
		for(PARAM p:this){
			if (p.getNom().equals(nom)){
				return p;
			}
		}
		return null;
	}
	
	public String erreur() {
		String retour = "(";
		boolean virg = false;
		for (PARAM p : this) {
			if(virg) {
				retour += "," + p.getType().getNom();
			} else {
				retour += p.getType().getNom();
				virg = true;
			}
		}
		retour += ")";
		return retour;
	}
	
	public int getDeplacement() {
		int retour = -1;
		for(PARAM p : this) {
			retour = Math.max(retour, p.getDeplacement());
		}
		return retour;
	}

	public int getTaille() {
		int retour = 0;
		for(PARAM p : this) {
			retour += p.getType().getTaille();
		}
		return retour;
	}
}


