package mjc.lib.classe;

import mjc.lib.type.DTYPE;

public class METHODE {

	protected String nom;
	protected DTYPE typeRetour;
	protected LPARAMS params;
//	protected boolean redefinie;
	protected String classe;

	public METHODE(String name,DTYPE t,LPARAMS pl){
		this.nom = name;
		this.typeRetour = t;
		this.params = pl;
//		this.redefinie = false;
		this.classe = "";
	}
	
	public METHODE(String name, DTYPE t, LPARAMS pl, String c) {
		this(name, t, pl);
		this.classe = c;
	}

	public String getNom() {
		return nom;
	}

	public DTYPE getType() {
		return typeRetour;
	}

	public LPARAMS getParams(){
		return params;
	}

	public boolean compareTo(METHODE m) {
		boolean ident = m.nom.equals(nom);
		boolean param = 
			(params == null && m.params == null) || (params.equals(m.params));
		return ident && param;
	}

	public String toString() {
		StringBuffer sb = new StringBuffer();
		if (typeRetour != null) {
			sb.append("Méthode : " + nom + "\n");
			sb.append("Retourne : " + typeRetour + "\n");
		} else {
			sb.append("Constructeur : " + nom + "\n");
		}
		if(!params.isEmpty()) {
			sb.append("Paramètres : \n");
			for(PARAM p : params) {
				sb.append("\t" + p + "\n");
			}	
		}
		return sb.toString();
	}
	
//	public boolean estRedefinie() {
//		return this.redefinie;
//	}
//
//	public void setRedefinie(boolean b) {
//		this.redefinie = b;
//	}

	public String getClasse() {
		return classe;
	}

}
