package mjc.lib.type;

public abstract class DTYPE {
	protected int taille;
	protected String nom;

	public DTYPE(String n, int t) {
		nom = n;
		taille = t;
	}

	public int getTaille() {
		return taille;
	}


	public String getNom() {
		return nom;
	}


	/** Efectue la comparaison entre 2 types.
	 * Vérifie si les types sont compatibles.
	 * @param autre Le type à comparer
	 * @return vrai si les types sont compatibles, faux sinon
	 */
	public boolean compareTo(DTYPE autre) {
		return (nom.equals("polymorphe"))||(autre.nom.equals("polymorphe"))||nom.equals(autre.nom);
	}
	
	/** Vérifie si deux types sont égaux.
	 * Cette méthode vérifie si les types ont même nom.
	 * @param o Le type à tester
	 * @return vrai si les types sont égaux, faux sinon
	 */
	public boolean equals(Object o) {
		if (o instanceof DTYPE) {
			return nom.equals(((DTYPE) o).nom);
		}
		
		return false;
	}

	public String toString() {
		return nom + "(" + taille + ")";
	}
}
