package mjc.lib.type;

import mjc.lib.classe.CLASSE;

public class POINTEUR extends DTYPE{
	private CLASSE classe;

	public POINTEUR(CLASSE c) {
		super("pointeur", 1);
		classe = c;
	}

	public CLASSE getClasse() {
		return classe;
	}
	
	/** Vérifie si les types sont compatibles.
	 * Pour cela, on va vérifier que les classes le sont (héritage par exemple).
	 */
	public boolean compareTo(DTYPE autre) {
		boolean retour = false;
		if(autre instanceof NULL) {
			retour = true;
		} else if (autre instanceof POINTEUR) {
			retour =  classe.compareTo(((POINTEUR) autre).classe);
		}
		return retour;
	}


	public String toString(){
		return super.toString() + " sur type = " + classe.getNom();
	}
}
